using System;
using System.Collections.Generic;
using System.Text;

namespace MofuMofu.Boosting
{
    /// <summary>
    /// ʊ
    /// </summary>
    public class StrongClassifier : Classifier
    {
        /// <summary>
        /// ʊ̃Xg
        /// </summary>
        private ClassifierConfList classifiers;
        public ClassifierConfList Classifiers
        {
            get { return this.classifiers; }
            set { this.classifiers = value; }
        }
        /// <summary>
        /// 臒ld
        /// </summary>
        private double thresholdTrimming;
        public double ThresholdTrimming
        {
            get { return this.thresholdTrimming; }
            set { this.thresholdTrimming = value; }
        }


        public StrongClassifier()
        {
            this.classifiers = new ClassifierConfList();
            this.thresholdTrimming = 1.0;
        }


        #region Classifier o
        /// <summary>
        /// ʊKp
        /// </summary>
        /// <param name="example"></param>
        /// <returns></returns>
        public int Test(Example example)
        {
	        //臒lvZ        	
	        double threshold = 0;
            for(int c=0; c<classifiers.Count; c++)
	        {
                threshold += classifiers[c].Conf;
	        }
	        threshold = threshold / 2.0;

	        //㎯ʊKp
	        double discrimination = 0.0;	
	        for(int c=0; c<classifiers.Count; c++)
	        {
                discrimination += (classifiers[c].Conf * classifiers[c].Test(example));
	        }

	        //臒lvZ
            double adjustedThreshold = threshold * thresholdTrimming;

            //
	        if(discrimination >= adjustedThreshold)
	        {
		        return 1;
	        }

	        return 0;
        }

        #endregion
    }
}
